"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = LOCAL_DB_HANDLER;
const grab_dsql_connection_1 = __importDefault(require("../../grab-dsql-connection"));
/**
 * # DSQL user read-only DB handler
 */
function LOCAL_DB_HANDLER(query, values) {
    return __awaiter(this, void 0, void 0, function* () {
        var _a;
        const CONNECTION = yield (0, grab_dsql_connection_1.default)();
        try {
            const results = yield CONNECTION.query(query, values);
            if (Array.isArray(results)) {
                return Array.from(results);
            }
            else {
                return results;
            }
        }
        catch (error) {
            (_a = global.ERROR_CALLBACK) === null || _a === void 0 ? void 0 : _a.call(global, `LOCAL_DB_HANDLER Error`, error);
            return {
                success: false,
                error: error.message,
            };
        }
        finally {
            yield (CONNECTION === null || CONNECTION === void 0 ? void 0 : CONNECTION.end());
        }
    });
}
