"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = NO_DB_HANDLER;
const grab_dsql_connection_1 = __importDefault(require("../../grab-dsql-connection"));
/**
 * # DSQL user read-only DB handler
 */
function NO_DB_HANDLER(query, values) {
    return __awaiter(this, void 0, void 0, function* () {
        var _a;
        const CONNECTION = yield (0, grab_dsql_connection_1.default)();
        try {
            return new Promise((resolve, reject) => {
                CONNECTION.query(query, values)
                    .then((results) => __awaiter(this, void 0, void 0, function* () {
                    if (Array.isArray(results)) {
                        resolve(Array.from(results));
                    }
                    else {
                        resolve(results);
                    }
                }))
                    .catch((err) => __awaiter(this, void 0, void 0, function* () {
                    resolve({
                        error: err.message,
                        sql: err.sql,
                    });
                }))
                    .finally(() => __awaiter(this, void 0, void 0, function* () {
                    yield (CONNECTION === null || CONNECTION === void 0 ? void 0 : CONNECTION.end());
                }));
            });
        }
        catch (error) {
            (_a = global.ERROR_CALLBACK) === null || _a === void 0 ? void 0 : _a.call(global, `NO_DB_HANDLER Error`, error);
            return {
                success: false,
                error: error.message,
            };
        }
    });
}
