import grabDSQLConnection from "../../grab-dsql-connection";

/**
 * # DSQL user read-only DB handler
 */
export default async function LOCAL_DB_HANDLER(query: string, values?: any[]) {
    const CONNECTION = await grabDSQLConnection();

    try {
        const results = await CONNECTION.query(query, values);

        if (Array.isArray(results)) {
            return Array.from(results);
        } else {
            return results;
        }
    } catch (error: any) {
        global.ERROR_CALLBACK?.(`LOCAL_DB_HANDLER Error`, error as Error);
        return {
            success: false,
            error: error.message,
        };
    } finally {
        await CONNECTION?.end();
    }
}
